//--------------------------------------
// Projectile
//--------------------------------------
datablock SniperProjectileData(DestroyerBeamLaser)
{
   directDamage        = 10.0;
   hasDamageRadius     = false;
   indirectDamage      = 0.0;
   damageRadius        = 0.0;
   velInheritFactor    = 1.0;
   sound 				  = SniperRifleProjectileSound;
   explosion           = "SniperExplosion";
   splash              = SniperSplash;
   directDamageType    = $DamageType::Mortar;

   maxRifleRange       = 2000;
   rifleHeadMultiplier = 1.3;
   beamColor           = "1 0.1 0.1";
   fadeTime            = 9.0;

   startBeamWidth		  = 5.0;
   endBeamWidth 	     = 5.0;
   pulseBeamWidth 	  = 2.5;
   beamFlareAngle 	  = 3.0;
   minFlareSize        = 0.0;
   maxFlareSize        = 400.0;
   pulseSpeed          = 6.0;
   pulseLength         = 0.150;

   lightRadius         = 1.0;
   lightColor          = "0.3 0.0 0.0";

   textureName[0]      = "special/flare";
   textureName[1]      = "special/nonlingradient";
   textureName[2]      = "special/laserrip01";
   textureName[3]      = "special/laserrip02";
   textureName[4]      = "special/laserrip03";
   textureName[5]      = "special/laserrip04";
   textureName[6]      = "special/laserrip05";
   textureName[7]      = "special/laserrip06";
   textureName[8]      = "special/laserrip07";
   textureName[9]      = "special/laserrip08";
   textureName[10]     = "special/laserrip09";
   textureName[11]     = "special/sniper00";

};

//--------------------------------------------------------------------------
// Projectile
//--------------------------------------
datablock TracerProjectileData(DestroyerBeamBullet)
{
   doDynamicClientHits = true;

   directDamage        = 0.0;
   hasDamageRadius     = true;
   indirectDamage      = 10.0;
   damageRadius        = 5.0;
   explosion           = "ScoutChaingunExplosion";
   splash              = ChaingunSplash;
   indirectDamageType    = $DamageType::mortar;
   kickBackStrength  = 100.0;

   sound = ShrikeBlasterProjectileSound;

   dryVelocity       = 100.0;
   wetVelocity       = 100.0;
   velInheritFactor  = 1.0;
   fizzleTimeMS      = 1000;
   lifetimeMS        = 30000;
   explodeOnDeath    = false;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 3000;

   tracerLength    = 1000.0;
   tracerAlpha     = false;
   tracerMinPixels = 6;
   tracerColor     = "1.0 1.0 1.0 1.0";
	tracerTex[0]  	 = "special/shrikeBolt";
	tracerTex[1]  	 = "special/shrikeBoltCross";
	tracerWidth     = 5.0;
   crossSize       = 0.99;
   crossViewAng    = 0.990;
   renderCross     = true;

};

//--------------------------------------------------------------------------
// Datablocks
//--------------------------------------

datablock SensorData(LaserTurretSensor) {
	detects = true;
	detectsUsingLOS = true;
	detectsPassiveJammed = false;
	detectsActiveJammed = false;
	detectsCloaked = false;
	detectionPings = true;
	detectRadius = 500;
};

datablock TurretData(LaserDeployed) : TurretDamageProfile {
	className = DeployedTurret;
	shapeFile = "camera.dts";
	mass = 5.0;
	maxDamage = 4.5;
	destroyedLevel = 4.5;
	disabledLevel = 4.49;
	explosion      = SmallTurretExplosion;
	expDmgRadius = 10.0;
	expDamage = 0.65;
	expImpulse = 500.0;
	repairRate = 0;
	heatSignature = 0.0;
	deployedObject = true;
	thetaMin = 5;
	thetaMax = 145;
	thetaNull = 90;
	primaryAxis = zaxis;
	isShielded = true;
	energyPerDamagePoint = 30;
	maxEnergy = 100;
	rechargeRate = 0.15;
	barrel = DeployableLaserBarrel;
	canControl = true;
	cmdCategory = "DTactical";
	cmdIcon = CMDTurretIcon;
	cmdMiniIconName = "commander/MiniIcons/com_turret_grey";
	targetNameTag = 'DestroyerLaser';
	targetTypeTag = 'Turret';
	sensorData = LaserTurretSensor;
	sensorRadius = LaserTurretSensor.detectRadius;
	sensorColor = "191 0 226";
	firstPersonOnly = true;
	renderWhenDestroyed = true;
	debrisShapeName = "debris_generic_small.dts";
	debris = TurretDebrisSmall;
};

datablock TurretImageData(DeployableLaserBarrel) {
	shapeFile = "turret_muzzlepoint.dts";
	item = LaserTurretBarrel;
	offset = "0 0 0";
	projectile = DestroyerBeamLaser;
	projectileType = SniperProjectile;
	usesEnergy = true;
	fireEnergy = 1;
	minEnergy = 8;
	lightType = "WeaponFireLight";
	lightColor = "0.25 0.15 0.15 1.0";
	lightTime = "1000";
	lightRadius = "2";
	muzzleFlash = IndoorTurretMuzzleFlash;
	 // Turret parameters
	activationMS = 150;
	deactivateDelayMS = 300;
	thinkTimeMS = 150;
	degPerSecTheta = 580;
	degPerSecPhi = 960;
	attackRadius = 1000;

	 // State transitions
	stateName[0] = "Activate";
	stateTransitionOnNotLoaded[0] = "Dead";
	stateTransitionOnLoaded[0] = "ActivateReady";

	stateName[1] = "ActivateReady";
	stateSequence[1] = "Activate";
	stateSound[1] = IBLSwitchSound;
	stateTimeoutValue[1] = 1;
	stateTransitionOnTimeout[1] = "Ready";
	stateTransitionOnNotLoaded[1] = "Deactivate";
	stateTransitionOnNoAmmo[1] = "NoAmmo";

	stateName[2] = "Ready";
	stateTransitionOnNotLoaded[2] = "Deactivate";
	stateTransitionOnTriggerDown[2] = "Fire";
	stateTransitionOnNoAmmo[2] = "NoAmmo";

	stateName[3] = "Fire";
	stateTransitionOnTimeout[3] = "Reload";
	stateTimeoutValue[3] = 0.0;
	stateFire[3] = true;
	stateShockwave[3] = true;
	stateRecoil[3] = LightRecoil;
	stateAllowImageChange[3] = false;
	stateSequence[3] = "Fire";
	stateSound[3] = IBLFireSound;
	stateScript[3] = "onFire";

	stateName[4] ="Reload";
	stateTimeoutValue[4] = 10.0;
	stateAllowImageChange[4] = false;
	stateSequence[4] = "Reload";
	stateTransitionOnTimeout[4] = "Ready";
	stateTransitionOnNotLoaded[4] = "Deactivate";
	stateTransitionOnNoAmmo[4] = "NoAmmo";

	stateName[5] = "Deactivate";
	stateSequence[5] = "Activate";
	stateDirection[5] = false;
	stateTimeoutValue[5] = 0.1;
	stateTransitionOnLoaded[5] = "ActivateReady";
	stateTransitionOnTimeout[5] = "Dead";

	stateName[6] = "Dead";
	stateTransitionOnLoaded[6] = "ActivateReady";

	stateName[7] = "NoAmmo";
	stateTransitionOnAmmo[7] = "Reload";
	stateSequence[7] = "NoAmmo";
};

datablock ShapeBaseImageData(TurretLaserDeployableImage) {
	mass = 15;
	shapeFile = "pack_deploy_turreti.dts";
	item = TurretLaserDeployable;
	mountPoint = 1;
	offset = "0 0 0";
	deployed = LaserDeployed;
	stateName[0] = "Idle";
	stateTransitionOnTriggerDown[0] = "Activate";

	stateName[1] = "Activate";
	stateScript[1] = "onActivate";
	stateTransitionOnTriggerUp[1] = "Idle";

	isLarge = true;
	emap = true;
	maxDepSlope = 360;
	deploySound = TurretDeploySound;
	minDeployDis =  0.5;
	maxDeployDis =  5.0;
};

datablock ItemData(TurretLaserDeployable) {
	className = Pack;
	catagory = "Deployables";
	shapeFile = "pack_deploy_turreti.dts";
	mass = 3.0;
	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 1;
	rotate = false;
	image = TurretLaserDeployableImage;
	pickUpName = "a laser turret pack";
	emap = true;
};

//--------------------------------------------------------------------------
// Functions
//--------------------------------------

function TurretLaserDeployableImage::TestNoTerrainFound(%item) {
	// created to prevent console errors
}

function TurretLaserDeployableImage::TestNoInteriorFound(%item) {
	// created to prevent console errors
}

function TurretLaserDeployable::onPickup(%this, %obj, %shape, %amount) {
	//created to prevent console errors
}

function LaserDeployed::onDestroyed(%this, %obj, %prevState) {
	if (%obj.isRemoved)
		return;
	if ($Host::InvincibleDeployables != 1 || %obj.damageFailedDecon) {
		%obj.isRemoved = true;
		$TeamDeployedCount[%obj.team, TurretLaserDeployable]--;
		remDSurface(%obj);
		%obj.schedule(500, delete);
	}
	Parent::onDestroyed(%this, %obj, %prevState);

}

function DeployableLaserBarrel::onFire(%data,%obj,%slot) 

{ 
%energy = %obj.getEnergyLevel(); 

%p = new (SniperProjectile)() { 
dataBlock = DestroyerBeamLaser; 
initialDirection = %obj.getMuzzleVector(%slot); 
initialPosition = %obj.getMuzzlePoint(%slot); 
sourceObject = %obj; 
damageFactor = 1; 
sourceSlot = %slot; 
}; 

%p.setEnergyPercentage(1); 
%obj.lastProjectile = %p; 
MissionCleanup.add(%p); 
serverPlay3D(LazeRifleFireSound, %obj.getTransform()); 
%obj.setEnergyLevel(0); 

}